#include <TGUI/TGUI.hpp>
#include "PortableFileDialogs.hpp"
#include "PortableFileDialogsWrapper.hpp"

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

namespace tgui
{
    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    bool PortableFileDialog::requirementsMet()
    {   return pfd::settings::available();  }

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    void PortableFileDialog::notify(std::string const &title,
                                    std::string const &text,
                                    PortableFileDialog::Icon icon)
    {
        pfd::notify(title, text, (pfd::icon)icon);
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    PortableFileDialog::Buttons PortableFileDialog::message(std::string const &title,
                                                            std::string const &message,
                                                            PortableFileDialog::Choice choice,
                                                            PortableFileDialog::Icon icon)
    {
        return (tgui::PortableFileDialog::Buttons)pfd::message(title, message, (pfd::choice)choice, (pfd::icon)icon).result();
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    std::vector<std::string> PortableFileDialog::fileOpen(std::string const &title,
                                                          std::string const &initialPath,
                                                          std::vector<std::string> filter,
                                                          PortableFileDialog::FileDialogOptions options)
    {
        auto dialog = pfd::open_file(title, initialPath, filter, (pfd::opt)options);

        // Do something while waiting for user input
        while (!dialog.ready(200));

        return dialog.result();
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    std::string PortableFileDialog::fileSave(std::string const &title,
                                             std::string const &initialPath,
                                             std::vector<std::string> filter,
                                             PortableFileDialog::FileDialogOptions options)
    {
        auto dialog = pfd::save_file(title, initialPath, filter, (pfd::opt)options);

        // Do something while waiting for user input
        while (!dialog.ready(200));

        return dialog.result();
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    std::string PortableFileDialog::folderSelect(std::string const &title,
                                                 std::string const &initialPath,
                                                 PortableFileDialog::FileDialogOptions options)
    {
        auto dialog = pfd::select_folder(title, initialPath, (pfd::opt)options);

        // Do something while waiting for user input
        while (!dialog.ready(200));

        return dialog.result();
    }

    /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
